## ros-foxy-maliput-object 0.1.2

=== CMakeLists.txt ===
##############################################################################
# Project
##############################################################################

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(maliput_object LANGUAGES C CXX VERSION 3.0.0)

##############################################################################
# Find 3rd Party Packages
##############################################################################

message(STATUS "\n\n====== Finding 3rd Party Packages ======\n")

find_package(ament_cmake REQUIRED)
find_package(fmt 6.1.2 EXACT REQUIRED)
find_package(maliput REQUIRED)
find_package(yaml-cpp REQUIRED)

##############################################################################
# Project Configuration
##############################################################################

message(STATUS "\n\n========= Project Configuration ========\n")

set(BUILD_SHARED_LIBS true)

include(${PROJECT_SOURCE_DIR}/cmake/DefaultCFlags.cmake)
include(${PROJECT_SOURCE_DIR}/cmake/SanitizersConfig.cmake)


##############################################################################
# Docs
##############################################################################

if(BUILD_DOCS)
  message(STATUS "Doxygen generation - Enabled")
  find_package(ament_cmake_doxygen REQUIRED)
    ament_doxygen_generate(doxygen_maliput_object
      CONFIG_OVERLAY doc/Doxyfile.overlay.in
      TEST_ON_WARNS
    )
  add_definitions(-DBUILD_DOCS)
else()
  message(STATUS "Doxygen generation - Disabled")
endif()

##############################################################################
# Sources
##############################################################################
add_subdirectory(src)

##############################################################################
# Tests
##############################################################################

if(BUILD_TESTING)
  find_package(ament_cmake_clang_format REQUIRED)
  enable_testing()
  add_subdirectory(test)
  ament_clang_format(CONFIG_FILE ${CMAKE_CURRENT_SOURCE_DIR}/.clang-format)
endif()

##############################################################################
# Export
##############################################################################

install(
  DIRECTORY include/
  DESTINATION include
)

ament_export_include_directories(include)

ament_export_dependencies(ament_cmake)
ament_export_targets(${PROJECT_NAME}-targets HAS_LIBRARY_TARGET)
ament_package()

=== src/CMakeLists.txt ===
add_subdirectory(api)
add_subdirectory(base)
add_subdirectory(loader)

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)
find_package(ament_cmake_gmock REQUIRED)

add_subdirectory(api)
add_subdirectory(base)
add_subdirectory(loader)

=== include/maliput_object/CMakeLists.txt ===
add_subdirectory(api)
add_subdirectory(base)
add_subdirectory(loader)
add_subdirectory(test_utilities)

=== src/api/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(API_SOURCES
  object.cc
)

add_library(api ${API_SOURCES})

add_library(maliput_object::api ALIAS api)

set_target_properties(api
  PROPERTIES
    OUTPUT_NAME maliput_object_api
)

target_include_directories(api
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(api
  PUBLIC
  maliput::api
  maliput::common
)

##############################################################################
# Export
##############################################################################

include(CMakePackageConfigHelpers)

install(
  TARGETS api
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== src/base/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(BASE_SOURCES
  manual_object_book.cc
  simple_object_query.cc
)

add_library(base ${BASE_SOURCES})

add_library(maliput_object::base ALIAS base)

set_target_properties(base
  PROPERTIES
    OUTPUT_NAME maliput_object_base
)

target_include_directories(base
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(base
  PUBLIC
  maliput::api
  maliput::common
  maliput::math
  maliput::routing
  maliput_object::api
)

##############################################################################
# Export
##############################################################################

include(CMakePackageConfigHelpers)

install(
  TARGETS base
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== src/loader/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(LOADER_SOURCES
  loader.cc
)

add_library(loader ${LOADER_SOURCES})

add_library(maliput_object::loader ALIAS loader)

set_target_properties(loader
  PROPERTIES
    OUTPUT_NAME maliput_object_loader
)

target_include_directories(loader
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(loader
  PUBLIC
  maliput::common
  maliput::math
  maliput_object::api
  maliput_object::base
  yaml-cpp
)

##############################################################################
# Export
##############################################################################

include(CMakePackageConfigHelpers)

install(
  TARGETS loader
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== test/api/CMakeLists.txt ===
ament_add_gmock(object_book_test object_book_test.cc)
ament_add_gmock(object_test object_test.cc)
ament_add_gmock(object_query_test object_query_test.cc)

macro(add_dependencies_to_test target)
if (TARGET ${target})

      target_include_directories(${target}
        PRIVATE
          ${PROJECT_SOURCE_DIR}/include
          ${CMAKE_CURRENT_SOURCE_DIR}
          ${PROJECT_SOURCE_DIR}/test
      )

      target_link_libraries(${target}
          maliput::api
          maliput::common
          maliput::math
          maliput::test_utilities
          maliput_object::api
      )

    endif()
endmacro()

add_dependencies_to_test(object_book_test)
add_dependencies_to_test(object_query_test)
add_dependencies_to_test(object_test)

=== test/base/CMakeLists.txt ===
ament_add_gmock(manual_object_book_test manual_object_book_test.cc)
ament_add_gmock(simple_object_query_test simple_object_query_test.cc)

macro(add_dependencies_to_test target)
    if (TARGET ${target})

      target_include_directories(${target}
        PRIVATE
          ${PROJECT_SOURCE_DIR}/include
          ${CMAKE_CURRENT_SOURCE_DIR}
          ${PROJECT_SOURCE_DIR}/test
      )

      target_link_libraries(${target}
        maliput::api
        maliput::common
        maliput::test_utilities
        maliput_object::api
        maliput_object::base
      )

    endif()
endmacro()

add_dependencies_to_test(manual_object_book_test)
add_dependencies_to_test(simple_object_query_test)

=== test/loader/CMakeLists.txt ===
ament_add_gtest(loader_test loader_test.cc)

macro(add_dependencies_to_test target)
    if (TARGET ${target})

      target_include_directories(${target}
        PRIVATE
          ${PROJECT_SOURCE_DIR}/include
          ${CMAKE_CURRENT_SOURCE_DIR}
          ${PROJECT_SOURCE_DIR}/test
      )

      target_link_libraries(${target}
        fmt::fmt
        maliput::api
        maliput::common
        maliput::test_utilities
        maliput_object::api
        maliput_object::base
        maliput_object::loader
      )

    endif()
endmacro()

add_dependencies_to_test(loader_test)

=== debian/changelog ===
ros-foxy-maliput-object (0.1.2-1focal) focal; urgency=high

  * Moves BoundingRegion, BoundingBox and OverlappingType to maliput (#44 <https://github.com/maliput/maliput_object/issues/44>)
  * Adds triage workflow. (#43 <https://github.com/maliput/maliput_object/issues/43>)
  * Improves README. (#42 <https://github.com/maliput/maliput_object/issues/42>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Tue, 16 Aug 2022 03:00:00 -0000

ros-foxy-maliput-object (0.1.1-1focal) focal; urgency=high

  * Fixes include folder installation. (#41 <https://github.com/maliput/maliput_object/issues/41>)
  * Uses ros-action-ci for main workflow. (#40 <https://github.com/maliput/maliput_object/issues/40>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Tue, 21 Jun 2022 03:00:00 -0000

ros-foxy-maliput-object (0.1.0-1focal) focal; urgency=high

  * Use <doc_depend> for ament_cmake_doxygen dependency. (#39 <https://github.com/maliput/maliput_object/issues/39>)
  * Moves package to root. (#38 <https://github.com/maliput/maliput_object/issues/38>)
  * Removes maliput_object_py from the repo (#37 <https://github.com/maliput/maliput_object/issues/37>)
  * Updates license. (#35 <https://github.com/maliput/maliput_object/issues/35>)
  * Uses ament_export_targets. (#34 <https://github.com/maliput/maliput_object/issues/34>)
  * Adds testing support for LoadFile to parse objects from a YAML. (#33 <https://github.com/maliput/maliput_object/issues/33>)
  * Creates bindings for the maliput::object::api namespace (#31 <https://github.com/maliput/maliput_object/issues/31>)
  * Implements the loader for ObjectBook (#32 <https://github.com/maliput/maliput_object/issues/32>)
  * Adds maliput_object_py to CI. (#30 <https://github.com/maliput/maliput_object/issues/30>)
  * Creates the package for the python bindings (#29 <https://github.com/maliput/maliput_object/issues/29>)
  * Adds documentation about the YAML specification for objects. (#24 <https://github.com/maliput/maliput_object/issues/24>)
  * Adds missing BoundingBox::box_size() method defintion. (#28 <https://github.com/maliput/maliput_object/issues/28>)
  * Adds ManualObjectBook. (#23 <https://github.com/maliput/maliput_object/issues/23>)
  * Updates misleading OverlappingType's docstring. (#26 <https://github.com/maliput/maliput_object/issues/26>)
  * Adds a SimpleObjectQuery implementation (#17 <https://github.com/maliput/maliput_object/issues/17>)
  * Adds BoundingBox Implementation (#7 <https://github.com/maliput/maliput_object/issues/7>)
  * Improves OverlappingTest definition. (#16 <https://github.com/maliput/maliput_object/issues/16>)
  * Adds ObjectQuery class. (#13 <https://github.com/maliput/maliput_object/issues/13>)
  * Creates ObjectBook API (#12 <https://github.com/maliput/maliput_object/issues/12>)
  * Creates Object class (#8 <https://github.com/maliput/maliput_object/issues/8>)
  * Adds BoundingRegion api class. (#6 <https://github.com/maliput/maliput_object/issues/6>)
  * Setup maliput_object repository/package (#2 <https://github.com/maliput/maliput_object/issues/2>)
  * Initial commit
  * Contributors: Agustin Alba Chicar, Franco Cipollone, Voldivh

 -- Daniel Stonier <daniel.stonier@tri.global>  Fri, 10 Jun 2022 03:00:00 -0000

=== debian/control ===
Source: ros-foxy-maliput-object
Section: misc
Priority: optional
Maintainer: Daniel Stonier <daniel.stonier@tri.global>
Build-Depends: debhelper (>= 9.0.0), libfmt-dev, libgflags-dev, libyaml-cpp-dev, ros-foxy-ament-cmake, ros-foxy-ament-cmake-clang-format <!nocheck>, ros-foxy-ament-cmake-gmock <!nocheck>, ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-maliput, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-maliput-object
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfmt-dev, libgflags-dev, libyaml-cpp-dev, ros-foxy-maliput, ros-foxy-ros-workspace
Description: Maliput Object

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-maliput-object//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
